//Complex functions on shaders (uses float2 as data structure)


//Modulus
float Modulus(float2 input)
{
     return sqrt(input.x * input.x + input.y * input.y);
}

//Complex to power (power as real)
float2 Power(float2 c, float power)
{
     float modulus =  pow(c.x * c.x + c.y * c.y, 0.5 * power);
     float a = atan2(c.y,c.x) * power;
     float2 result;
     result.x = modulus * cos(a);
     result.y = modulus * sin(a);
     return result;
}


//Multiplies two complex numbers
float2 Multiply(float2 c1, float2 c2)
{
	float2 result;
	result.x = (c1.x*c2.x - c1.y*c2.y);
	result.y = (c1.x*c2.y + c1.y*c2.x);
	return result;
}

//Add two complex numbers
float2 Add(float2 c1, float2 c2)
{
	float2 result;
	result.x = c1.x + c2.x;
	result.y = c1.y + c2.y;
	return result;
}


